//キャラクタLCDコントローラHD44780	命令定義／拡張命令定義
//	『昼夜逆転』工作室	http://jsdiy.webcrow.jp
//	2017/06

#ifndef HD44780_INSTRUCTION_H_
#define HD44780_INSTRUCTION_H_


//行の動作を設定する拡張命令
#define	LCD_LINEMODE_SEPARATE	0b00	//1行目と2行目は独立している
#define	LCD_LINEMODE_COMBINE	0b01	//1行目行末から2行目行頭へ自動的に続く。全体として1行目行頭が表示領域の先頭、2行目行末が末尾
//
#define	LCD_LINEMODE_STOP		0b00	//末尾で停止。末尾を越える書き込みは無視
#define	LCD_LINEMODE_OVERWRITE	0b10	//末尾から先頭へ戻り、上書きで書き込み続行。カーソルが強制表示される（画面のどこまで表示が進んだか分かるように）
//
#define	LCD_CURSOR_ON	1	//カーソルを表示する。上書きモードの場合に役立つ
#define	LCD_CURSOR_OFF	0	//カーソルを表示しない。

//HD44780 Instruction
#define	LCD_CMD_CLEAR_DISPLAY	0b00000001
#define	LCD_CMD_RETURN_HOME		0b00000010
#define	LCD_CMD_ENTRY_MODE		0b00000100
#define	LCD_CMD_DISPLAY_MODE	0b00001000
#define	LCD_CMD_CURSOR_MODE		0b00010000
#define	LCD_CMD_FUNCTION_SET	0b00100000
#define	LCD_CMD_SET_CGRAM_ADRS	0b01000000
#define	LCD_CMD_SET_DDRAM_ADRS	0b10000000

//HD44780 Instructionのパラメータ
//(LCD_CMD_AAA | LCD_SUBCMD_XXX1 | LCD_SUBCMD_XXX2 | …)の形で使う

//LCD_CMD_ENTRY_MODE
#define	LCD_SUBCMD_INCREMENT	0b00000010	//入力位置を進める（無指定だとDecrement）
#define	LCD_SUBCMD_WITH_SHIFT	0b00000001	//表示シフト動作を伴う（LCD_CMD_CURSOR_MODEも設定する）

//LCD_CMD_DISPLAY_MODE
#define	LCD_SUBCMD_SET_DISPLAY	0b00000100	//画面表示する（無指定だと表示内容を保ったまま画面を消す）
#define	LCD_SUBCMD_SET_CURSOR	0b00000010	//カーソルを表示する（アンダーバーを表示する）
#define	LCD_SUBCMD_CURSOR_BLINK	0b00000001	//カーソルを点滅させる（文字に被さって黒マスが点滅する）

//LCD_CMD_CURSOR_MODE
#define	LCD_SUBCMD_SHIFT_ON		0b00001000	//DDRAMの変更無しに表示をシフトさせる（無指定だとカーソルを移動させる）
#define	LCD_SUBCMD_RIGHT		0b00000100	//右へシフトさせる（無指定だと左へ）※上記、カーソル移動モード時は意味を持たない

//LCD_CMD_FUNCTION_SET
#define	LCD_SUBCMD_DL8BIT		0b00010000	//Data Length 8-bit（無指定だと4-bitモード）
#define	LCD_SUBCMD_2LINE		0b00001000	//表示で2行使用する（無指定だと1行のみ使用可能になる）
#define	LCD_SUBCMD_FONT5X10		0b00000100	//Font Type 5x10（無指定だと5x8）※SC1602/SD1602は物理的に非対応


#endif	//HD44780_INSTRUCTION_H_
