//	キャラクタLCD/HD44780互換コントローラ ライブラリ
//	『昼夜逆転』工作室	@jsdiy	http://jsdiy.webcrow.jp
//	2020/04

//SUNLIKE [SC1602]												|[SD1602]
//pin:	14	13	12	11	10	9	8	7	6	5	4	3	2	1	|16	15
//bit:	DB7	DB6	DB5	DB4	DB3	DB2	DB1	DB0	E	R/W	RS	Vo	VDD	VSS	|K	A
//		<- 4bit mode ->									+V	GND	|-	+

#ifndef HD44780_LCDLIB_H_
#define HD44780_LCDLIB_H_


#include "HD44780_Instruction.h"

//ポート割り当ての例
//bit:		7	6	5	4	3	2	1	0
//portD:	-	RS	E	-	DB4	DB5	DB6	DB7

//ポート設定
#define	LCD_PORT	PORTD
#define	LCD_DDR		DDRD
//
#define	LCD_RS	(1 << PORTD6)	//Register Select	H:data	L:command
#define	LCD_E	(1 << PORTD5)	//Enable Signal		H->L:strobe
#define	LCD_DB_SHIFT	0	//portのLSB側から何ビットめがデータビットか。例：bit3-0なら0、bit7-4なら4
#define	LCD_DB_REVERSE	1	//データ線とportの結線順	0:portのLSB側がDB4	1:portのMSB側がDB4

//関数
void	LCD_Init(uint8_t columnSize, uint8_t rowSize);
void	LCD_SetLineMode(uint8_t lineMode, uint8_t cursorFlag);
void	LCD_SetPos(uint8_t row_y, uint8_t column_x);
void	LCD_Clear(void);
void	LCD_PutChar(char cc);
void	LCD_PutString(const char* str);
void	LCD_PutStringP(const char* strpgm);
void	LCD_PutUInt(uint16_t n);
void	LCD_PutInt(int16_t n);
void	LCD_PutByte(uint8_t n);
void	LCD_PutWord(uint16_t n);
void	LCD_DefChar(uint8_t id, const uint8_t* dots);


#endif	//HD44780_LCDLIB_H_
