//f[^ANZXEf[^H
//wt]xH쎺	@jsdiy
//	2020/04

#include <avr/io.h>
#include <avr/eeprom.h>
#include "dataaccess.h"

//Oobt@
/*
yACẽTCYz
ۑf[^ł̓ACeƌĂԁB
TSensorValueIuWFNgACeB

yOobt@̃TCYz
TSensorValue\̃TCY x ACe

yۑ[z
ACe͏Ƀobt@ŌɒǉۑBobt@̂A擪㏑ĂB
obt@rʒũACe㏑邱Ƃ͂ȂBǂ̈ʒũACe폜邱Ƃ͂ȂB
*/

//ۑf[^iACej\
typedef	struct
{
	int16_t	temp;
	int16_t	pres;
}
TItem;

//ۑ\ȃACe
#define MAX_ITEM_COUNT	GRAPHPARAM_LENGTH

//ACẽCfbNX
//E蓾l (0 <= itemidx < MAX_ITEM_COUNT)B
static	uint8_t	idxItemFirst;	//擪iŌÁj̃ACewCfbNXFACe㏑ƂɍXV
static	uint8_t	idxItemLast;	//iŐVj̃ACewCfbNXFACeۑ邲ƂɍXV
#define	NO_INDEX	0xFE

//EEPROM̕ۑ̈
static	EEMEM	TItem	EM_RingBuffer[MAX_ITEM_COUNT];	//Oobt@{
static	EEMEM	uint8_t	EM_IndexItemFirst = 0;			//idxItemFirst̒l
static	EEMEM	uint8_t	EM_IndexItemLast = NO_INDEX;	//idxItemLast̒l

//obt@̊֐
static	uint8_t	NextItemIndex(uint8_t itemidx);

//֐
static	uint8_t	IsFirstBoot(void);
static	void	SensorValueToItem(const TSensorValue* val, TItem* item);
static	void	ItemToGraphParam(const TItem* item, uint16_t* grParamTemp, uint16_t* grParamPres);


//
void	DA_Init(void)
{
	//Oobt@̓ǂݏʒu擾iN͕ϐ錾Ɏw肵lj
	eeprom_busy_wait();	idxItemFirst = eeprom_read_byte(&EM_IndexItemFirst);
	eeprom_busy_wait();	idxItemLast = eeprom_read_byte(&EM_IndexItemLast);
}

//Nۂ̊mF
static	uint8_t	IsFirstBoot(void)
{
	//EEPROMiACeۑĂȂԁj idxItemLast == NO_INDEX łB
	return (idxItemLast == NO_INDEX);
}

//wʒu̎̃ACeCfbNXԂ
static	uint8_t	NextItemIndex(uint8_t itemidx)
{
	if (++itemidx >= MAX_ITEM_COUNT) { itemidx = 0; }
	return itemidx;
}

//lۑf[^ɕϊ
static	void	SensorValueToItem(const TSensorValue* val, TItem* item)
{
	//x(-40.0`85.0)
	item->temp = val->temp.integer * 10 + val->temp.decimal;	//-400`850
	
	//C(300.0`1100.0)
	item->pres = val->pres.integer * 10 + val->pres.decimal;	//3000`11000
}

//ۑf[^Ot`pf[^ɕϊ
static	void	ItemToGraphParam(const TItem* item, uint16_t* grParamTemp, uint16_t* grParamPres)
{
	*grParamTemp = (uint16_t)(item->temp + 400);	//0`1250
	*grParamPres = (uint16_t)(item->pres - 3000);	//0`8000
}

//lۑ
void	DA_Save(const TSensorValue* val)
{
	//ACeۑCfbNX߂
	//E̕ۑCfbNX擪ʒuɒǂA擪ʒu֐i߂B
	if (IsFirstBoot())
	{
		idxItemLast = 0;
	}
	else
	{
		idxItemLast = NextItemIndex(idxItemLast);
		if (idxItemLast == idxItemFirst) { idxItemFirst = NextItemIndex(idxItemFirst); }
	}
	
	//ACeCfbNXۑ
	eeprom_busy_wait();	eeprom_write_byte(&EM_IndexItemFirst, idxItemFirst);
	eeprom_busy_wait();	eeprom_write_byte(&EM_IndexItemLast, idxItemLast);
	
	//lۑf[^ɕϊ
	TItem item;
	SensorValueToItem(val, &item);
	
	//ACe
	eeprom_busy_wait();	eeprom_write_block(&item, &EM_RingBuffer[idxItemLast], sizeof(TItem));
}

//Otp̃f[^ǂݍ
void	DA_LoadGraphParam(ESensorType sensorType, TGraphParam* grParam)
{
	uint8_t	itemidx = idxItemFirst;
	uint8_t	doLoad = 1;		//idxItemLastǂݍ܂Ȃ悤ɂtO
	uint16_t	grbuf[2];	//Otpf[^i[obt@
	
	grParam->max = 0x0000;
	grParam->min = UINT16_MAX;
	
	if (IsFirstBoot()) { doLoad = 0; }	//f[^ۑĂȂԂŌĂяoꂽꍇ
	
	for (uint8_t i = 0; i < MAX_ITEM_COUNT; i++)
	{
		if (doLoad)
		{
			//ACeǂݍ
			TItem item;
			eeprom_busy_wait();	eeprom_read_block(&item, &EM_RingBuffer[itemidx], sizeof(TItem));
			
			//ACeOtpf[^ɕϊ
			ItemToGraphParam(&item, &grbuf[SENSOR_Temperature], &grbuf[SENSOR_Pressure]);
			
			//߂lɃZbg
			uint16_t num = grbuf[sensorType];
			grParam->datas[i] = num;
			
			//őlEŏlXV
			if (num != DA_NO_DATA)
			{
				if (grParam->max < num) { grParam->max = num; }
				if (grParam->min > num) { grParam->min = num; }
			}
			
			//̃ACeCfbNX߂iidxItemLastzȂ悤ɂj
			if (itemidx == idxItemLast) { doLoad = 0; }
			else { itemidx = NextItemIndex(itemidx); }
		}
		else
		{
			grParam->datas[i] = DA_NO_DATA;
		}
	}
}
